#include <stdio.h>
#include <mpi.h>

int main(int argc, char* argv[])
{
    const int FILESIZE = 32*32*32*4;

    MPI_Init(&argc, &argv);

    int writebuf[FILESIZE], tmpbuf[FILESIZE];
    const int bufcount = FILESIZE;

    int nprocs, mynod;
    MPI_Request request;
    MPI_Status status;

    MPI_Comm_size(MPI_COMM_WORLD, &nprocs);
    MPI_Comm_rank(MPI_COMM_WORLD, &mynod);

    MPI_Irecv(tmpbuf, bufcount, MPI_INT, mynod, 10, MPI_COMM_WORLD, &request);
    MPI_Send(writebuf, bufcount, MPI_INT, mynod, 10, MPI_COMM_WORLD);
    MPI_Wait(&request, &status);


    MPI_Finalize();
}
