program main
    use mpi_f08

    implicit none

    integer, parameter :: FILESIZE = 32*32*32*4

    integer :: ierr
    integer, dimension(FILESIZE) :: writebuf, tmpbuf
    integer :: bufcount

    integer :: nprocs, mynod
    type(MPI_Request) :: request
    type(MPI_Status) :: status

    writebuf = 1
    tmpbuf = 0

    bufcount = FILESIZE


    call MPI_Init(ierr)

    call MPI_Comm_size(MPI_COMM_WORLD, nprocs, ierr)
    call MPI_Comm_rank(MPI_COMM_WORLD, mynod, ierr)

    call MPI_Irecv(tmpbuf, bufcount, MPI_INTEGER, mynod, 10, MPI_COMM_WORLD, request, ierr)
    call MPI_Send(writebuf, bufcount, MPI_INTEGER, mynod, 10, MPI_COMM_WORLD, ierr)
    call MPI_Wait(request, status, ierr)

    call MPI_Finalize(ierr)
end program
